
if (!BenchmarkEmailTools) {
	var BenchmarkEmailTools = {};
	var benchmarkStoredtoken=null;	
	var currentTab=null;
    var currBenchmarkAcc="";
	var imageProcess=false;
	var currentBtab=null;
};

if (!BenchmarkEmailTools.TransProcess) {
	BenchmarkEmailTools.TransProcess = {};
};
BenchmarkEmailTools.TransProcess ={
	
	init:function()
	{ 
		var e=document.createElement('script');
		e.setAttribute('src','mimic/mimic.js');
		document.body.appendChild(e);
		 
		var e=document.createElement('script');
		e.setAttribute('src','jquery.js');
		document.body.appendChild(e);

        BenchmarkEmailTools.TransProcess.checkToken();
	//  chrome.browserAction.onClicked.addListener(BenchmarkEmailTools.TransProcess.setPopup);
	},
	checkToken:function()
	{ 
		chrome.storage.sync.get('benchmarkToken', function(item){ benchmarkStoredtoken=item.benchmarkToken;  
				if(!benchmarkStoredtoken || benchmarkStoredtoken=="null") { 
				  chrome.browserAction.setIcon({path:"plugin-icon-grey19.png"});

		}
		else { 
				  chrome.browserAction.setIcon({path:"plugin-icon_19.png"});
				  chrome.contextMenus.create({
				  "id": "benchmarkEmail",
				  "title" : "Benchmark - Add Image",
				  "type" : "normal",
				  "contexts" : ["image"],
				  "onclick" : BenchmarkEmailTools.TransProcess.getClickHandler()
				});	
			}
			});
	},
	passwordRecovery:function()
	{
		chrome.tabs.create({'url': 'https://ui.benchmarkemail.com/ForgotPassword'}, function(tab) {  });
	},
//	setPopup:function()
//	{ 
//		//chrome.storage.sync.get('benchmarkToken', function(item){ token=item.value; });
//
//		if(!token) {
//			chrome.tabs.executeScript(null, {file: "jquery.js"});
//			chrome.tabs.executeScript(null, {file: "backgroundScript.js"});
//		}
//		else
//    		BenchmarkEmailTools.TransProcess.userLogout();
//		
//	},
	userLogout:function()
	{ 
		token=null;
		chrome.tabs.executeScript(null, {file: "jquery.js"});
		chrome.tabs.executeScript(null, {file: "popup.js"});
		chrome.browserAction.setIcon({path:"plugin-icon-grey19.png"});
		chrome.storage.sync.remove("benchmarkToken");

		chrome.contextMenus.remove("benchmarkEmail",function removeContextMenu(){ });
	},   
	userLogin:function(eventMsgArr)
	{				   
			   currBenchmarkAcc= eventMsgArr[0];
			   var requestLogin = BenchmarkEmailTools.TransProcess.getXmlRpcRequest("login"); 
			   chrome.storage.sync.set({"currBenchmarkAcc": currBenchmarkAcc});

			   requestLogin.addParam(eventMsgArr[0]); 
               requestLogin.addParam(eventMsgArr[1]);
               var responseLogin = requestLogin.send();
			   benchmarkStoredtoken = responseLogin.parseXML(); 				  
			   if (benchmarkStoredtoken.substring) {
				   	 chrome.browserAction.setIcon({path:"plugin-icon_19.png"});
				   	 benchmarkStoredtoken=benchmarkStoredtoken.toString();
					 chrome.storage.sync.set({"benchmarkToken": benchmarkStoredtoken});
				chrome.contextMenus.create({
				  "id": "benchmarkEmail",
				  "title" : "Benchmark - Add Image",
				  "type" : "normal",
				  "contexts" : ["image"],
				  "onclick" : BenchmarkEmailTools.TransProcess.getClickHandler()
				});	
				return 'success';

			  } else
				  {
					benchmarkStoredtoken=null;
				    loggedStatus = false;
					alert('The login and/or password that you have entered does not appear to be correct. Please try again.');
					return;
				  }			
	},
	getXmlRpcRequest:function(method)
	{
		 var request = new XmlRpcRequest("http://api.benchmarkemail.com/1.0", method);
		 return request;
	},
	resetBenchmarkEET : function(token)
	{
		benchmarkStoredtoken= token;
		chrome.storage.sync.set({"benchmarkToken": token});
		chrome.browserAction.setIcon({path:"plugin-icon-grey19.png"});
	    chrome.contextMenus.remove("benchmarkEmail",function removeContextMenu(){ });

	},
	getClickHandler:function() {
		return function(info, tab) {
			var imageUrl=info.srcUrl; 
            currentTab=tab;
//			chrome.tabs.executeScript(tab.id, {file: "jquery.js"});
//			chrome.tabs.executeScript(tab.id, {file: "benchmarkBScript.js"});			
			BenchmarkEmailTools.TransProcess.addimage(imageUrl);

		};
	},
//	getImageInfoHandler:function(url) {
//		return function(){
//			var imageinfo = ImageInfo.getAllFields(url); 
//			BenchmarkEmailTools.TransProcess.addimage(imageinfo,url);
//		 };
//	},
    addImgCallback:function(addImgAsyResp)
	{ 
		var imageTrans = addImgAsyResp.parseXML();  
		if(imageTrans)
		{ 
			imageProcess=false;
			//chrome.tabs.getSelected(null, function(tab) {
			  chrome.tabs.sendMessage(currentBtab, {imageTransRes: "true"});
			//});
		}
		else
		{
			imageProcess=false;
			//chrome.tabs.getSelected(null, function(tab) {
			  chrome.tabs.sendMessage(currentBtab, {imageTransRes: "false"});
			//});
		}

	},
		
	addimage:function(url) { 
		currentBtab = null;
		chrome.tabs.getSelected(null, function(tab) {
//			 chrome.tabs.executeScript(tab.id, {file: "jquery.js"});
//           chrome.tabs.insertCSS(tab.id, {file: "plugin-popups.css"});
          currentBtab =tab.id;
		  chrome.tabs.sendMessage(currentBtab, {appendPrgsPopup: "appendPrgsPopup"}, function(response) {
		
		imageProcess = true;
		chrome.contextMenus.update("benchmarkEmail", {"title" :"Benchmark - Adding Image...","onclick" : function(){  }});

		try
		{
		var canvas = document.createElement("canvas");
		var ctx = canvas.getContext("2d");
		var img = new Image();
    	var data=null;
		img.onload = function () { 
			canvas.width = img.width;
			canvas.height = img.height;
			ctx.drawImage(img, 0, 0);
    		data = canvas.toDataURL();
			data= data.replace(/^data:image\/(png|jpg);base64,/, "");
			var request = BenchmarkEmailTools.TransProcess.getXmlRpcRequest("imageAdd");
			request.addParam(benchmarkStoredtoken); 
			var ImageData=new Object();
			ImageData['image_name']='image1';
		    //ImageData['image_url']=url; 
			ImageData['image_data']=data; 
			//ImageData['image_height']=imageinfo.height+'px'; 
 		    //ImageData['image_width']=imageinfo.width+'px';
		    request.addParam(ImageData);
			var response = request.send_async(BenchmarkEmailTools.TransProcess.addImgCallback); 			

			};
        img.src = url;
        }
		catch (e)
		{
		   console.log("error-"+e);
		}
		}); });
    },
}

BenchmarkEmailTools.TransProcess.init();
chrome.extension.onMessage.addListener(
  function(request, sender, sendResponse) { 
       //if (request.userLogin.benchmarkEmail && request.userLogin.benchmarkPwd)
	   if(request.modifyContextMenu=="true")
             chrome.contextMenus.update("benchmarkEmail", {"title" :"Benchmark - Add Image","onclick" : BenchmarkEmailTools.TransProcess.getClickHandler() });	  
		});
chrome.windows.onCreated.addListener(function(win) {  BenchmarkEmailTools.TransProcess.checkToken(); });
